//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "3d.h"

// 
//     sϊ֐		void SetMatrix()
// @@`敔֐		void RenderParactice( struct XFILE *car )

void Render()
{
	// @.obNobt@ Z obt@NA
	g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

	// A.`Jnʒm
	if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
	{
		// B.sϊ
		SetMatrix();
		// C.`s
		RenderParactice( &charactor );
		// D.`Iʒm
		g_pd3dDevice->EndScene();
	}
	// E.obNobt@vC}obt@ɃRs[
	g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}


void SetMatrix()
{
	// [hϊ
	D3DXMATRIXA16	matWorld,matworld2;
	D3DXMatrixTranslation( &matWorld, 0, 0, 0  );			// sړs쐬
	D3DXMatrixRotationY( &matworld2, timeGetTime()/1000.0f );// ]
	matWorld *= matworld2;
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );	// D3Dɍsn

	// r[ϊ
	D3DXMATRIXA16 matView;	// sL\
	D3DXVECTOR3 vEyePt( 0.0f, 1.0f,-2.0f );		// Jʒu
	D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );	// _
	D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );		// xNg
	D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );	// r[ϊs̍쐬
	g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );				// D3Dɍsn

	// ˉeϊ
	D3DXMATRIXA16 matProj;
	D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );	// ˉeϊs̍쐬
	g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );				// D3Dɍsn
}


void RenderParactice( struct XFILE *car )
{
	for( DWORD i = 0 ; i < car->NumMaterial ; i++ )
	{
		g_pd3dDevice->SetMaterial( &car->Mat[i] );	// }eA
		g_pd3dDevice->SetTexture( 0, car->Tex[i] );	// eNX`
		car->lpMesh->DrawSubset( i );				// bV
	}
}
