//-----------------------------------------------------------------------------
// CN[ht@C
//-----------------------------------------------------------------------------
#include "3d.h"

//--------------------------------------------------------------
HWND				g_hWnd = NULL;
LPDIRECT3D9			g_pD3D = NULL;
LPDIRECT3DDEVICE9	g_pd3dDevice = NULL;
struct XFILE		charactor;


//--------------------------------------------------------------




// --------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case	WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

// --------------------------------------------------------------
HRESULT WindowMake( HINSTANCE hInst )
{
	WNDCLASSEX wc;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize         = sizeof(WNDCLASSEX); 
	wc.lpfnWndProc    = (WNDPROC)WndProc;
	wc.hInstance      = hInst;
	wc.hCursor        = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground  = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszClassName  = (LPCSTR)MYWNDCLASS;
	RegisterClassEx(&wc);

	g_hWnd = CreateWindowEx(
		0,
		MYWNDCLASS,
		TITLE,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, 640, 480,
		NULL,
		NULL,
		hInst,
		NULL
	);
	if( !g_hWnd ) return FALSE;

	return TRUE;
}

// --------------------------------------------------------------
int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow )
{
	MSG msg;

	// EBhE̍쐬
	WindowMake( hInst );

	// 
	if( SUCCEEDED( InitD3D() ) )
	{
		// bV̓ǂݍ
		if( LoadMesh( &charactor, "data/ball.x" ) == FALSE )
		{
			MessageBox( g_hWnd, "wt@C̓ǂݍ݂ł܂BB","WinMain",MB_OK );
		}
		else
		{
			// EBhE𒆉ɕ\
			SetWinCenter( g_hWnd );

			// EBhE̕\
			ShowWindow( g_hWnd, nCmdShow );

			// bZ[W[v
			while ( msg.message !=  WM_QUIT )
			{
				if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
				else
				{
					// `
					Render();
				}
			}
		}
	}
	else
	{
		MessageBox( g_hWnd, "Direct3D̏ł܂łB","WinMain",MB_OK );
	}

	// J
	CleanUp();

	return msg.wParam;
}



// EBhE𒆉ɕ\
int SetWinCenter(HWND hWnd)
{
    HWND hDeskWnd;
    RECT deskrc, rc;
    int x, y;
    
    hDeskWnd = GetDesktopWindow();
    GetWindowRect(hDeskWnd, (LPRECT)&deskrc);
    GetWindowRect(hWnd, (LPRECT)&rc);
    x = (deskrc.right - (rc.right-rc.left)) / 2;
    y = (deskrc.bottom - (rc.bottom-rc.top)) / 2;
    SetWindowPos(hWnd, HWND_TOP, x, y, (rc.right-rc.left), (rc.bottom-rc.top),SWP_SHOWWINDOW); 
    return 0;
}
